package cligenerator

import (
	"fmt"
	"os"
	"path"
	"strings"
	"text/template"
	"time"

	util "l1-hlt-prescales-toolkit/internal/generators/util"
)

// GenerateAll the cli files in /src/cli
func GenerateAll() {
	externals, err := util.GetExternals()
	if err != nil {
		panic(err)
	}

	for _, external := range externals {
		GenerateCLICommand(external)
	}
}

func splitCommand(s string) []string {
	return strings.Split(s, " ")
}

func lastCommand(s string) string {
	pieces := splitCommand(s)
	if len(pieces) == 0 {
		return ""
	}
	return pieces[len(pieces)-1]
}

func penultimateCommand(s string) string {
	pieces := splitCommand(s)
	if len(pieces) < 2 {
		return "root"
	}
	return pieces[len(pieces)-2]
}

type cliTemplateData struct {
	Timestamp      time.Time
	Config         *util.ExternalConfig
	UsageString    string
	Prefix         string
	RequiredArgs   []util.ExternalConfigArg
	TemplatedFlags []util.ExtendedFlag
	Folder         string
}

var cliTemplate = template.Must(template.New("").Funcs(template.FuncMap{
	"makeStringArray":    util.TemplateStringArray,
	"capitalize":         util.Capitalize,
	"noSpaces":           util.NoSpaces,
	"splitCommand":       splitCommand,
	"lastCommand":        lastCommand,
	"penultimateCommand": penultimateCommand,
}).Parse(`// Code generated by go generate; DO NOT EDIT.
// This file was generated by robots at {{ .Timestamp }}
package main

import (
	{{- if .RequiredArgs }}
	"errors"
	{{ end }}
	"l1-hlt-prescales-toolkit/internal/scriptrunner"
	"l1-hlt-prescales-toolkit/internal/scriptrunner/external"
	"sync"
	"os"
	{{ $regexp := false}}
	{{- range $arg := .Config.Args }}
	{{- if $arg.Regex }}
	{{- $regexp = true }}
	{{- end }}
	{{- end }}
	{{- if $regexp }}
	"regexp"
	{{ end }}

	"github.com/spf13/cobra"
	{{ $viper := false}}
	{{- range $flag := .TemplatedFlags }}
	{{- if $flag.Configkey }}
	{{- $viper = true }}
	{{- end }}
	{{- end }}
	{{- if $viper }}
	"github.com/spf13/viper"
	{{ end }}
)

var {{ lastCommand .Config.Command }}Cmd = &cobra.Command{
	Use:        "{{ .UsageString }}",
	Aliases:    {{ makeStringArray .Config.Aliases }},
	{{ if .Config.Deprecated -}}
	Deprecated: "{{ .Config.Deprecated }}",
	{{- end }}
	Hidden:     {{ .Config.Hidden }},
	{{ if .Config.Short -}}
	Short:      "{{ .Config.Short }}",
	{{- end }}
	{{ if .Config.Long -}}
	Long:       "{{ .Config.Long }}",
	{{- end }}
	{{ if .Config.Example -}}
	Example:    "{{ .Config.Example }}",
	{{- end }}
	Args: func(cmd *cobra.Command, args []string) error {
		{{- range $i, $arg := .RequiredArgs }}
		if len(args) == {{ $i }} {
			return errors.New("{{ $arg.Required }}")
		}
		{{- end }}
		
		{{ range $i, $arg := .Config.Args -}}
		{{- if $arg.Regex -}}
		var {{ $arg.Name }} string
		if len(args) > {{ $i }} {
			{{ $arg.Name }} = args[{{ $i }}]
		}
		{{ if $arg.DefaultValue -}}
		if {{ $arg.Name }} == "" {
			{{ $arg.Name }} = "{{ $arg.DefaultValue }}"
		}
		{{ end -}}
		if match, _ := regexp.MatchString("{{ $arg.Regex }}", {{ $arg.Name }}); !match {
			{{ if $arg.Errormsg -}}
			return errors.New("{{ $arg.Errormsg }}")
			{{- else -}}
			return errors.New("argument {{ $arg.Name }} does not pass validation regex")
			{{- end }}
		}

		{{ end -}}
		{{ end -}}
		return nil
	},
	Run: func(cmd *cobra.Command, args []string) {
		{{- range $flag := .TemplatedFlags }}
		{{- if $flag.Configkey }}
		if *{{ noSpaces $.Config.Command }}_{{ $flag.Name }} == {{ $flag.ZeroValue }} {
			*{{ noSpaces $.Config.Command }}_{{ $flag.Name }} = viper.GetString("{{ $flag.Configkey }}")
		}
		{{- end }}
		{{- if $flag.DefaultValue }}
		if *{{ noSpaces $.Config.Command }}_{{ $flag.Name }} == {{ $flag.ZeroValue }} {
			*{{ noSpaces $.Config.Command }}_{{ $flag.Name }} = {{ $flag.QuotedDefault }}
		}
		{{- end }}
		{{- end }}
		{{ range $i, $arg := .Config.Args -}}
		var arg_{{ $arg.Name }} string
		if len(args) > {{ $i }} {
			arg_{{ $arg.Name }} = args[{{ $i }}]
		}
		{{ if $arg.DefaultValue -}}
		if arg_{{ $arg.Name }} == "" {
			arg_{{ $arg.Name }} = "{{ $arg.DefaultValue }}"
		}
		{{ end -}}
		{{ end }}
		stdout, stderr, fd3, done := external.{{ capitalize (noSpaces .Config.Command) }}(
		{{- range $i, $arg := .Config.Args -}}
		{{- if $i }}, {{ end -}}
		arg_{{ $arg.Name }}
		{{- end -}}
		{{- range $i, $flag := .Config.Flags -}}
		{{- if $i }}, {{ else if len $.Config.Args }}, {{ end -}}
		*{{ noSpaces $.Config.Command }}_{{ $flag.Name }}
		{{- end -}}
		)
		var wg sync.WaitGroup
		wg.Add(3)
		go scriptrunner.ChannelToStdout(&wg, "{{ .Prefix }} (stdout)", stdout)
		go scriptrunner.ChannelToStdout(&wg, "{{ .Prefix }} (fd3)", fd3)
		go scriptrunner.ChannelToStderr(&wg, "{{ .Prefix }} (stderr)", stderr)
		wg.Wait()
		if err := <-done; err != nil {
			log.WithError(err).WithField("command", "{{ .Prefix }}").Fatal("command failed")
			os.Exit(1)
		} else {
			log.WithError(err).Info("command succeeded")
		}
	},
}

{{- range $flag := .TemplatedFlags }}
var {{ noSpaces $.Config.Command }}_{{ $flag.Name }} *{{ $flag.GoType }}
{{- end }}

func init() {
	{{ penultimateCommand .Config.Command }}Cmd.AddCommand({{ lastCommand .Config.Command }}Cmd)
	
	{{- range $flag := .TemplatedFlags }}
	{{ noSpaces $.Config.Command }}_{{ $flag.Name }} = {{ noSpaces $.Folder }}Cmd.Flags().{{ capitalize $flag.GoType }}
	{{- if $flag.Short }}P{{ end -}}
	("{{ $flag.Name }}",
	{{- if $flag.Short }} "{{ $flag.Short }}",{{ end -}}
	{{" "}}{{ $flag.QuotedDefault}}, "{{ $flag.Description }}")
	{{- if $flag.Configkey }}
	viper.BindPFlag("{{ $flag.Configkey }}", {{ noSpaces $.Folder }}Cmd.Flags().Lookup("{{ $flag.Name }}"))
	{{- end }}
	{{- end }}
}
`))

// GenerateCLICommand generates the cli for the given package name
func GenerateCLICommand(name util.ExternalPackage) {

	config, err := util.ReadConfig(name)
	if err != nil {
		panic(err)
	}

	cwd, err := os.Getwd()
	if err != nil {
		panic(err)
	}

	fileName := "../../../cmd/pstools/generated_" + string(name) + ".go"
	fullPath := path.Join(cwd, fileName)
	fmt.Println("generating", fullPath)

	f, err := os.Create(fullPath)
	if err != nil {
		panic(err)
	}
	defer f.Close()

	err = cliTemplate.Execute(f, cliTemplateData{
		Timestamp:      time.Now(),
		Config:         config,
		UsageString:    buildUsageString(config),
		Prefix:         config.Command,
		RequiredArgs:   filterRequiredArgs(config.Args),
		TemplatedFlags: util.ExtendFlags(config.Flags),
		Folder:         string(name),
	})
	if err != nil {
		panic(err)
	}
}

func buildUsageString(config *util.ExternalConfig) string {
	r := lastCommand(config.Command)
	for _, arg := range config.Args {
		required := arg.Required != ""
		if required {
			r += " ["
		} else {
			r += " <"
		}
		r += arg.Name
		if required {
			r += "]"
		} else {
			r += ">"
		}
	}
	return r
}

func filterRequiredArgs(all []util.ExternalConfigArg) []util.ExternalConfigArg {
	r := make([]util.ExternalConfigArg, 0)
	for _, a := range all {
		if a.Required != "" {
			r = append(r, a)
		}
	}
	return r
}
